Index: units/admin/admin_events_handler.php
===================================================================
--- units/admin/admin_events_handler.php	(revision 14318)
+++ units/admin/admin_events_handler.php	(working copy)
@@ -453,7 +453,17 @@
 	 */
 	function OnStartup(&$event)
 	{
+		if ( $this->Application->isAdmin ) {
+			return ;
+		}
 
+		$base_url = preg_quote($this->Application->BaseURL(), '/');
+		$referrer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '';
+
+		if ( $referrer && !preg_match('/^' . $base_url . '/', $referrer) ) {
+			$this->Application->Session->SetCookie('original_referrer', $referrer);
+			$this->Application->SetVar('original_referrer', $referrer);
+		}
 	}
 
 	/**
Index: units/forms/form_submissions/form_submissions_eh.php
===================================================================
--- units/forms/form_submissions/form_submissions_eh.php	(revision 14318)
+++ units/forms/form_submissions/form_submissions_eh.php	(working copy)
@@ -223,9 +223,13 @@
 			$object->SetDBField('IPAddress', $_SERVER['REMOTE_ADDR']);
 
 			if ( !$object->GetDBField('ReferrerURL') ) {
-				$base_url = preg_quote($this->Application->BaseURL(), '/');
-				$referrer = preg_replace('/^' . $base_url . '/', '/', $_SERVER['HTTP_REFERER'], 1);
+				$referrer = $this->Application->GetVar('original_referrer');
 
+				if (!$referrer) {
+					$base_url = preg_quote($this->Application->BaseURL(), '/');
+					$referrer = preg_replace('/^' . $base_url . '/', '/', $_SERVER['HTTP_REFERER'], 1);
+				}
+
 				$object->SetDBField('ReferrerURL', $referrer);
 			}
 
